# $Id$

%define name		limewire
%define version		2.8
%define release		1jpp
%define javadir		%{_datadir}/java
%define javadocdir	%{_datadir}/javadoc
%define set_jvm		[ -f %{_bindir}/java-functions ] && . %{_bindir}/java-functions; set_jvm; export PATH=$PATH:$JAVA_HOME/bin

# These are needed in order to build successfully on non-Mandrake systems.
%{!?_menudir:		%define _menudir   %{_libdir}/menu}
%{!?_miconsdir:		%define _miconsdir %{_datadir}/icons/mini}
%{!?_iconsdir:		%define _iconsdir  %{_datadir}/icons}
%{!?_liconsdir:		%define _liconsdir %{_datadir}/icons/large}

Summary:		Gnutella peer-to-peer (P2P) file sharing system
Name:			%{name}
Version:		%{version}
Release:		%{release}
Url:			http://www.%{name}.com/
Source0:		%{name}_latest.zip
Source1:		%{name}-16.png
Source2:		%{name}-32.png
Source3:		%{name}-48.png
Patch0:			%{name}-java1.4-nomacosx.patch
Patch1:			%{name}-multiuser.patch
License:		GPL
Group:			Networking/File transfer
BuildArch:		noarch
Requires:		javalayer0.1.1 = 0.1.1
Requires:		jpackage-utils
Requires:		xerces-j1
BuildRequires:		ant
BuildRequires:		javalayer0.1.1 = 0.1.1
BuildRequires:		jpackage-utils
BuildRequires:		xerces-j1
BuildRoot:		%{_tmppath}/%{name}-%{version}-root

%description
Limewire is a gnutella client written in Java. It supports a number of
advanced features like ultrapeers (like FastTrack's supernodes), automatic
download retries, freeloader punishment, etc.

%package javadoc
Summary:        	Javadoc for %{name}
Group:			Development/Java

%description javadoc
Javadoc for %{name}.

%package mdkmenu
Summary:		Mandrake menu entry for %{name}
Group:			Development
Requires:		%{name} = %{version}-%{release}

%description mdkmenu
This is a Mandrake menu system entry for %{name}.

%package rhmenu
Summary:		Red Hat menu entry for %{name}
Group:			Development
Requires:		%{name} = %{version}-%{release}

%description rhmenu
This is a Red Hat menu system entry for %{name}.

%prep
%setup -n %{name}
# fix perms
(find . -type d | xargs chmod 755) || :
(find . -type f | xargs chmod 644) || :
%patch0 -p1 -b '~'
%patch1 -p1 -b '~'
install -m 644 %{SOURCE1} %{name}-16.png
install -m 644 %{SOURCE2} %{name}-32.png
install -m 644 %{SOURCE3} %{name}-48.png
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
find . -name "*.class" -exec rm -f {} \;
# remove quicktime for java
find . -name "*.zip" -exec rm -f {} \;
rm -f gui/com/limegroup/gnutella/gui/mp3/QuickTimeAudioPlayer.java
# set the version
perl -p -i -e "s#\@version\@#%{version}#" core/com/limegroup/gnutella/util/CommonUtils.java

%build
%set_jvm
export CLASSPATH=\
%{javadir}/javalayer-0.1.1.jar:\
%{javadir}/xerces-j1.jar:\
$RPM_BUILD_DIR/%{name}/core

(cd core && ant core)
#(cd core && jar cf core.jar `find . -name \*.class`)
(cd gui && ant runlimejar)
find . -name "RunLime*.class" -exec rm -f {} \;
(cd core && jar cf ../LimeWire.jar `find . -name "*.class"`)
(cd gui && jar uf ../LimeWire.jar `find . -name "*.class" -o -name "*.gif"`)
(cd gui && jar uf ../LimeWire.jar `find . -name "about*.html"`)
(cd gui/lib && jar cf ../../MessagesBundles.jar `find . -name MessagesBundle\*.properties`)
rm -f gui/Copyright.txt gui/README.txt gui/gpl.txt
mv -f core/README.txt core/core-README.txt
mv -f `find . -name "*.txt"` . || :
(cd core && javadoc -d ../doc `find . -name \*.java`)
(cd gui && javadoc -d ../doc `find . -name \*.java`)

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 LimeWire.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 MessagesBundles.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 gui/RunLime.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 gui/xml.war $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 gui/lib/MessagesBundle.properties $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}

# mdk icons
install -D -m 644 %{name}-48.png $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png
install -D -m 644 %{name}-32.png $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png
install -D -m 644 %{name}-16.png $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png

# mdk menu
install -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(%{name}):\
 command="%{_bindir}/%{name}"\
 needs="X11"\
 section="Networking/File transfer"\
 title="LimeWire"\
 longtitle="LimeWire - Gnutella client"\
 icon="limewire.png"
EOF

# rh icons
install -D -m 644 %{name}-48.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -D -m 644 %{name}-32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -D -m 644 %{name}-16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png

# rh menu
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Networking
cat >$RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Networking/%{name}.desktop <<EOF
[Desktop Entry]
Name=LimeWire
Comment=LimeWire - Gnutella client
Exec=%{_bindir}/%{name}
Terminal=0
Type=Application
Icon=%{name}.png
EOF

# script
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
cat > $RPM_BUILD_ROOT%{_bindir}/%{name} << EOF
#!/bin/sh
#
# jedit script
# JPackage Project (http://jpackage.sourceforge.net)

# Source functions library
if [ -f %{_bindir}/java-functions ] ; then
  . %{_bindir}/java-functions
else
  echo "Can't find functions library, aborting"
  exit 1
fi

# Source system prefs
if [ -f %{_sysconfdir}/%{name}.conf ] ; then
  . %{_sysconfdir}/%{name}.conf
fi

# Source user prefs
if [ -f \$HOME/.%{name}rc ] ; then
  . \$HOME/.%{name}rc
fi

# Configuration
MAIN_CLASS="RunLime"
BASE_FLAGS="-mx32m"
BASE_JARS="\
javalayer-0.1.1.jar \
xerces-j1.jar \
%{_datadir}/%{name}/LimeWire.jar \
%{_datadir}/%{name}/MessagesBundles.jar \
%{_datadir}/%{name}/RunLime.jar \
%{_datadir}/%{name}/xml.war"

# Set parameters
set_jvm
set_classpath \$BASE_JARS
set_flags \$BASE_FLAGS

# Let's start
run "\$@"
EOF

%post mdkmenu
%{update_menus}

%postun mdkmenu
%{clean_menus}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc *.txt
%attr(755,root,root) %{_bindir}/%{name}
%{_datadir}/%{name}

%files javadoc
%defattr(-,root,root)
%{javadocdir}/%{name}-%{version}

%files mdkmenu
%defattr(-,root,root)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files rhmenu
%defattr(-,root,root)
%{_sysconfdir}/X11/applnk/*/*
%{_datadir}/icons/*/*/apps/*

%changelog
* Wed Feb 19 2003 David Walluck <david@anti-microsoft.org> 2.2.8-1jpp
- release
